# -*- coding: utf-8 -*-
from setuphelpers import *
import platform
import json

bin_contains = "TurboVNC-"


def update_package():
    # Declaring local variables
    result = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name
    project_repo = "turbovnc"
    api_url = "https://sourceforge.net/projects/%s/best_release.json" % project_repo
    sub_bin_name = bin_contains + "%s-x86_64.dmg"
    # Getting latest version information from official sources
    print("API used is: %s" % api_url)
    json_load = json.loads(wgets(api_url, proxies=proxies))
    for download in json_load["platform_releases"]:
        if bin_contains in json_load["platform_releases"][download]["filename"]:
            version = json_load["platform_releases"][download]["filename"].split("/")[1]
            break
    latest_bin = sub_bin_name % version
    download_url = "https://sourceforge.net/projects/turbovnc/files/%s/%s/download" % (version, latest_bin)

    print("Latest %s version is: %s" % (app_name, version))
    print("Download URL is: %s" % download_url)

    # Downloading latest binaries
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)

    os.rename(latest_bin, sub_bin_name % version)


    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        result = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.version = "%s-%s" % (Version(version), control.version.split("-", 1)[-1])
    # control.set_software_version(version)
    control.save_control_to_wapt()

    # Deleting outdated binaries
    remove_outdated_binaries(version)

    # Validating update-package-sources
    return result
